
/*------------------------------------------------------------------
* class GeometryCanvas.
*
* author(s):  Diana Garroway
* date:       22-Oct-2003
*
* Description: This class listens for user input and handles the polygon
*              creation, correspondence and algorithm control.
*
* -------------------------------------------------------------------*/

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import java.awt.event.*;
import java.awt.*;

public class GeometryCanvas extends JPanel
                            implements MouseListener, ActionListener{
    //******************************************************************
    //  Member Variables
    //
    private cSimplePolygon m_inputPolygon;
    private InputPanel m_inputCanvas;

    //******************************************************************
    //  Constructors
    //
    public GeometryCanvas( String name, InputPanel in_iPanel){
        m_inputPolygon = new cSimplePolygon( name, in_iPanel );
        this.setBackground(Color.white);
        this.addMouseListener(this);

        Border l_canvasOutline = BorderFactory.createLineBorder(Color.black);
        Border l_title = BorderFactory.createTitledBorder(
		       l_canvasOutline, "Simple Polgon" + name);

        this.setBorder(l_title);

        m_inputCanvas = in_iPanel;

    }

    //******************************************************************
    //  Data Accessors
    //
    public cSimplePolygon GetInputPolygon(){
        return m_inputPolygon;
    }

    //******************************************************************
    //  Maintenance Methods
    //
   
    //******************************************************************
    //  Main Methods
    //
    public void mouseClicked( MouseEvent e ) {

    }

    public void mousePressed( MouseEvent e ) {
        cVertex l_vertex = new cVertex( e.getX(), e.getY(), m_inputPolygon.GetSize() );
        m_inputPolygon.AddVertex( l_vertex );
        this.repaint();
    }
    public void mouseReleased( MouseEvent e){

    }
    public void mouseEntered( MouseEvent e){

    }
    public void mouseExited( MouseEvent e){

    }

    public void actionPerformed(ActionEvent e) {
        this.repaint();
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g); //paint background
        m_inputPolygon.Draw( g );
    }
}
