import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * @author Diana Garroway
 */

/*
 * SimpleMorph.java requires these files:
 *   SwingWorker.java
 *   all the images in the images/tumble directory
 *     (or, if specified in the applet tag, another directory [dir]
 *     with images named T1.gif ... Tx.gif, where x is the total
 *     number of images [nimgs])
 *   the appropriate code to specify that the applet be executed,
 *     such as the HTML code in TumbleItem.html or TumbleItem.atag,
 *     or the JNLP code in TumbleItem.jnlp
 *
 * This applet compiles and runs in 1.4...other java versions have not
 * been tested.
 */
public class SimpleMorph extends JApplet
                        implements ActionListener {

    private JComponent m_contentPane; //the applet's content pane
    private InputPanel m_inputPanel;
    static StatusWindow m_statusWindow;

    //Called when this applet is loaded into the browser.
    public void init() {

        //Custom component to draw the current image
        //at a particular offset.
        m_contentPane = new JPanel(new BorderLayout()) {
            public void paintComponent(Graphics g) {
                super.paintComponent(g);
            }
        };

        m_contentPane.setOpaque(true);
        m_contentPane.setBackground(Color.white);

        m_statusWindow = new StatusWindow();
        m_inputPanel = new InputPanel();


        m_contentPane.add(m_inputPanel, BorderLayout.CENTER);
        m_contentPane.add(m_statusWindow, BorderLayout.SOUTH);
        setContentPane(m_contentPane);

        m_contentPane.repaint();
    }

    //Update the the loopslot (frame number) and the offset.
    //If it's the last frame, restart the timer to get a long
    //pause between loops.
    public void actionPerformed(ActionEvent e) {
        m_contentPane.repaint();
    }

    //Called to start the applet's execution.
    public void start() {

        m_contentPane.repaint();

    }

    //Called to stop (temporarily or permanently) the applet's execution.
    public void stop() {

    }

    public String getAppletInfo() {
        return "Title: SimpleMorph v1.0, 30 Nov 2003\n"
               + "Author: Diana Garroway\n"
               + "A demonstration of the algoritm presented in the paper:\n"
               + "         Guarenteed Intersection-Free Polygon Morphing \n"
               + "          By Craig Gotsman & Vitaly Surazhsky";
    }

    public String[][] getParameterInfo() {
        String[][] info = {
          //{"img", "string", "the directory containing the images to loop"},
        };
        return info;
    }
}
