/*------------------------------------------------------------------
* class cVertex.
*
* author(s):  Diana Garroway
* date:       Oct 20, 2003
*
* Class cEdge is used to represent an edge of a polygon or polyhydra
*-----------------------------------------------------------------------------*/

import java.util.ArrayList;
import java.util.List;
import java.awt.*;

public class cEdge {

  //******************************************************************
  //  Member Variables
  //
  private cVertex m_Endpt1;
  private cVertex m_Endpt2;
  private cVertex m_neighbour;

  //******************************************************************
  //  Constructors
  //
  public cEdge() {
    m_Endpt1 = new cVertex();
    m_Endpt2 = new cVertex();
    m_neighbour = null;
  }
  public cEdge( cVertex in_V1, cVertex in_V2 ){
     m_Endpt1 = in_V1;
     m_Endpt2 = in_V2;
     m_neighbour = null;
  }

   //******************************************************************
   //  Data Accessors
   //
   public List GetEdgePts (){
       List l_list = new ArrayList();
       l_list.add(m_Endpt1);
       l_list.add(m_Endpt2);
       return l_list;
   }
   public void SetEndPts( cVertex in_V1, cVertex in_V2){
       m_Endpt1 = in_V1;
       m_Endpt2 = in_V2;
   }
   public cVertex GetNeighbour(){
       return m_neighbour;
   }
   public void SetNeighbour( cVertex in_vertex){
        m_neighbour = in_vertex;
   }
   //******************************************************************
   //  Maintenance Methods
   //

    //********************************************************************
    //  Main Methods
    //
    public boolean MatchEdgePoints( cVertex in_1, cVertex in_2 ){
        if ( ( (in_1 == m_Endpt1) && (in_2 == m_Endpt2) )
                || ( (in_1 == m_Endpt2) && (in_2 == m_Endpt1) ) ){
            return true;
        }
        return false;
    }
    public void Draw( Graphics in_Graphic ){

        in_Graphic.drawLine( m_Endpt1.GetPoint().x, m_Endpt1.GetPoint().y, m_Endpt2.GetPoint().x, m_Endpt2.GetPoint().y);
    }
}
